; GUI #
include win64a.inc
; OpenGl Examples->mblur
; --------------- 
WINDOWWIDTH	= 440
WINDOWHEIGHT	= 400
;   blur'
;blurSize	= 512
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	hFile:QWORD	;handle of file
local	szReadWrite:QWORD	;number of bytes actually read or write
local	texture[196608]:byte

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
	
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,rbx
        mov	hFile,rax
	lea	edx,texture 
	lea	r9,szReadWrite
        invoke	ReadFile,eax,,196608,,0
        invoke	CloseHandle,hFile
;GLInit----------------------------------
;    
invoke glBlendFunc,GL_SRC_ALPHA,GL_ONE
;  
invoke glEnable,GL_BLEND
;   GL_LIGHT0 (   )
	invoke glEnable,GL_LIGHT0
; 
	invoke glEnable,GL_LIGHTING
;      
	invoke glEnable,GL_COLOR_MATERIAL
; 256x256x24bpp    texture (raw )
	mov	r9d,256
	mov	[rsp+20h],r9
	xor	edx,edx
	mov	[rsp+28h],rdx
	mov	qword ptr [rsp+30h],GL_RGB
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	lea	eax,texture
	mov	[rsp+40h],rax
	invoke glTexImage2D,GL_TEXTURE_2D,,3
;     (linear)
	invoke glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
;     (linear)
	invoke glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
; 
	invoke glEnable,GL_TEXTURE_2D
;     ()
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST
;     
	invoke glMatrixMode,GL_PROJECTION
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100_0
	movq	xmm2,constd0_1
	movq	xmm1,ratio
	movq	xmm0,constd90_0
	invoke gluPerspective
;    
	invoke glMatrixMode,GL_MODELVIEW
        jmp	wmBYE
wmSIZE:;;     
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
;    z-
	invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke glLoadIdentity
;     (z=-3.5)
	movd	xmm2,const_3_5
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glTranslatef
;       ( 
;     theta   x,y,z )
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1_0
	movd	xmm0,theta
	invoke glRotatef
	mov	eax,const1_0
	movd	xmm3,eax
	movd	xmm2,eax
	movd	xmm1,ebx
	movd	xmm0,theta
	invoke glRotatef
	movd	xmm3,const1_0
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,theta
	invoke glRotatef
;---------------------------------------
;    6  GL_QUADS ( 4  glVertex 
;  )
	invoke glBegin,GL_QUADS
; 1- 
	movd	xmm2,const1_0
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glNormal3f
;   1- 
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
;1- 
	movd	xmm2,const1_0
	mov	eax,const_1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
;   2- 
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glTexCoord2f
;2- 
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,const_1_0
	movd	xmm0,eax
	invoke glVertex3f
; ..
	movd	xmm1,ebx
	movd	xmm0,const1_0
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,const_1_0
	invoke glVertex3f
; 2- 
	movd	xmm2,const_1_0
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glNormal3f
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,ebx
	movd	xmm0,const1_0
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,const1_0
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glTexCoord2f
	movd	xmm2,const_1_0
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,const1_0
	invoke glVertex3f
; 3- 
	movd	xmm2,ebx
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glNormal3f
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,const1_0
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,const_1_0
	invoke glVertex3f
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm1,ebx
	movd	xmm0,const1_0
	invoke glTexCoord2f
	movd	xmm2,const_1_0
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
; 4- 
	movd	xmm2,ebx
	movd	xmm1,const_1_0
	movd	xmm0,ebx
	invoke glNormal3f
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	mov	eax,const1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm1,eax
	movd	xmm2,eax
	movd	xmm0,const1_0
	invoke glVertex3f
	movd	xmm1,ebx
	movd	xmm0,const1_0
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,const_1_0
	movd	xmm0,eax
	invoke glVertex3f
	movd	xmm0,ebx
	movd	xmm1,ebx
	invoke glTexCoord2f
	movd	xmm2,const1_0
	mov	eax,const_1_0
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
; 5- 
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const1_0
	invoke glNormal3f
	mov	eax,const1_0
	movd	xmm0,eax
	movd	xmm1,eax
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,const1_0
	invoke glVertex3f
	movd	xmm0,const1_0
	movd	xmm1,ebx
	invoke glTexCoord2f
	movd	xmm2,const_1_0
	mov	eax,const1_0
	movd	xmm0,eax
	movd	xmm1,eax
	invoke glVertex3f
	movd	xmm0,ebx
	movd	xmm1,ebx
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm0,eax
	movd	xmm1,eax
	movd	xmm2,eax
	invoke glVertex3f
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,const_1_0
	movd	xmm0,eax
	invoke glVertex3f
; 6- 
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const_1_0
	invoke glNormal3f
	movd	xmm1,const1_0
	movd	xmm0,ebx
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,eax
	invoke glVertex3f
	mov	eax,const1_0
	movd	xmm0,eax
	movd	xmm1,eax
	invoke glTexCoord2f
	movd	xmm2,const1_0
	mov	eax,const_1_0
	movd	xmm0,eax
	movd	xmm1,eax
	invoke glVertex3f
	movd	xmm0,const1_0
	movd	xmm1,ebx
	invoke glTexCoord2f
	mov	eax,const1_0
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,const_1_0
	invoke glVertex3f
	movd	xmm0,ebx
	movd	xmm1,ebx
	invoke glTexCoord2f
	mov	eax,const_1_0
	movd	xmm2,eax
	movd	xmm1,const1_0
	movd	xmm0,eax
	invoke glVertex3f
;  
	invoke glEnd
;----------------------------------------
;   
        invoke	SwapBuffers,hDC
;   theta
	fld	theta
;    delta
	fadd	delta
;  
	fstp	theta
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
;---------------------------------------------------------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR;  
  	nVersion          dw	1;  
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW ;  ,     
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	32;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	32;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

constd0_1	dq 0.1
constd90_0	dq 90.0
constd100_0	dq 100.0
ratio		dq 1.1
const_3_5	dd -3.5
const_1_0	dd -1.0
const1_0	dd 1.0
;   
delta dd 0.3
; 
theta dd ?
szClassName	db "Uncle Remus tales:#40 OpenGL - Alpha blending",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "prehistorik.raw",0
end